#!/usr/bin/python

import log4py
import sys

class Log4PyTest:

    def __init__(self):
        self.log4py = log4py.Logger().get_instance(self)

    def run(self):
        self.log4py.error("error")
        self.log4py.warn("hello")
        self.log4py.info("startup")
        self.log4py.debug("debug")

    def output(self, message):
        self.log4py.info(message)

mytest = Log4PyTest()

print "\nSettings from log4py.conf\n"
mytest.run()

print "\nNormal level - Long format (written to log4py-test.log)"
mytest.log4py.set_target("log4py-test.log")
mytest.run()
mytest.log4py.set_target(sys.stdout)

print "\nNormal level - Long format (ansi color)\n"
mytest.log4py.set_use_ansi_codes(log4py.TRUE)
mytest.run()
mytest.log4py.set_use_ansi_codes(log4py.FALSE)

print "\nDebug level - Debug format\n"
mytest.log4py.set_formatstring(log4py.FMT_DEBUG)
mytest.log4py.set_loglevel(log4py.LOGLEVEL_DEBUG)
mytest.run()

print "\nVerbose level - Medium format\n"
mytest.log4py.set_formatstring(log4py.FMT_MEDIUM)
mytest.log4py.set_loglevel(log4py.LOGLEVEL_VERBOSE)
mytest.run()

print "\nNormal, long format - Testing Nested Diagnostic Context\n"
mytest.log4py.set_formatstring(log4py.FMT_LONG)
mytest.log4py.set_loglevel(log4py.LOGLEVEL_VERBOSE)
mytest.log4py.push("ndc1")
mytest.output("Should say \"ndc1\"");
mytest.log4py.push("ndc2")
mytest.output("Should say \"ndc1 ndc2\"");
mytest.log4py.pop()
mytest.output("Should say \"ndc1\"");
mytest.log4py.push("ndc3")
mytest.output("Should say \"ndc1 ndc3\"");
mytest.log4py.clear_ndc();
mytest.output("Should not have any ndc items");
